_CH375_INC_	.SET	1

	.INCLUDE inc\global.inc
	.INCLUDE inc\dirp00.inc
	.INCLUDE INC\LDT.INC
	
.LIST on

; page 0 local var's (declared in bios temp. work area)
_P0BTMP:	.SECTION page0, ref_only, offset bwrktmp	; DP Tmp. BIOS
USB0TMP_START	.EQU	$
usbtmp		.DB
nretry		.DB
seccnt		.DB
pktcnt		.DB
lba		.DS	4
bufndx		.DW
bufp		LP
tlp		LP
fatsize		.DW
wseccnt		.DW
freecnt		.DW
nxtfree		.DW
cluster		.DW
maxcls		.DW
clssiz		.DB
sec256		.DB
usbbuf		.EQU	fatsize

	.EXTERN PAGE0 ldt4

USB0TMP_SIZ	.EQU	($-USB0TMP_START)
	.ENDS

;---------------------------------------------------------------------------
; code segment -- bank $F8
;---------------------------------------------------------------------------

	.CODEF8
	
	.LONGA	off
	.LONGI	off

; called by ISR after plug flash disk 
usbdskon:
	.PUBLIC usbdskon

	lda	#CB2IFRB
	sta	!VIA3+VIAIER	; for now disable ch37x interrupt
	lda	#10
	sta	nretry		; retries times
	lda	#$40
	tsb	usb0st		; set bit <6>: plugged in
	bit	usb0ch
	bvc	?ch5		; ch375
	jmp	?ch6		; ch376
	
	; ch375: first of all send command CMD_DISK_INIT
	;
?ch5:	jsr	delay10ms	; delay
	lda	#CMD_DISK_INIT	; init usb disk on ch375
	jsr	cmdwait
	bcc	?nxt
	bit	usb0st
	bvc	?off		; disconnected
	lda	usb0st
	lsr	a
	bcc	?nod		; no flash disk
	dec	nretry
	bne	?ch5		; try again
	bra	?nod		; no chances	
?nxt:	lda	#0
	sta	nretry
?ch51:	jsr	delay10ms
	lda	#CMD_DISK_SIZE	; get total sectors & sector size
	jsr	cmdwait
	bcc	?nxt2
	bit	usb0st
	bvc	?off		; disconnected
	lda	usb0st
	lsr	a
	bcc	?nod		; no flash disk
?dec:	dec	nretry
	bne	?ch51		; try again	
	beq	?nod		; no chances
?nxt2:	lda	#CMD_RD_USB_DATA
	sta	!usb0cmd	; read 8 bytes
	nop
	nop
	nop
	nop

	; expect 8 bytes: 32 bit for total sectors...
	; followed by 32 bit for sector size

	lda	!usb0dat
	cmp	#$08
	bne	?dec		; retry
	
	; data are in big endian, so get in reverse order
	ldx	#7
?lp1:	lda	!usb0dat
	sta	usbbuf,x
	dex
	bpl	?lp1
	lda	usbbuf+1
	cmp	#$02		; just 512 bytes per sec.
	bne	?nod		; unsupported sector size		
	lda	#CMD_PREFIX	; set packet size per sector
	sta	!usb0cmd
	nop
	nop
	nop
	lda	#PFX_SET_PKT_P_SEC
	sta	!usb0dat
	nop
	lda	#$08		; one sector = 8 packets (1 pack = 64 bytes)
	sta	!usb0dat
	lda	usbbuf+4
	sta	usbsec
	lda	usbbuf+5
	sta	usbsec+1
	lda	usbbuf+6
	sta	usbsec+2
	lda	usbbuf+7
	sta	usbsec+3
	bra	?dev

?nod:	lda	#$20
	tsb	usb0st		; unknow device plugged
	jmp	?end
	
?off:	lda	#$7F
	trb	usb0st		; device unplugged
	jmp	?end

	; handle flash disk plug on ch376 chip
?ch6:	jsr	delay10ms	; delay
	lda	#CMD_DISK_MOUNT	; try to mount flash disk
	jsr	cmdwait
	bcc	?nxt3
	bit	usb0st
	bvc	?off		; disconnected
	lda	usb0st
	lsr	a
	bcc	?nod		; no flash disk
	dec	nretry
	beq	?nod		; no chances
	bne	?ch6		; try again	
?nxt3:	stz	nretry
?nxt31:	jsr	delay10ms	; delay
	lda	#CMD_DISK_CAPACITY
	jsr	cmdwait
	bcc	?nxt4
	bit	usb0st
	bvc	?off		; disconnected
	lda	usb0st
	lsr	a
	bcc	?nod		; no flash disk
?dec1:	dec	nretry
	beq	?nod		; no chances
	bne	?nxt31		; try again	
?nxt4:	lda	#CMD_RD_USB_DATA
	sta	!usb0cmd	; expect 4 bytes
	nop
	nop
	nop
	nop
	lda	!usb0dat
	cmp	#$04
	bne	?dec1		; retry
	ldy	#4
	ldx	#0
?lp2:	lda	!usb0dat
	sta	usbsec,x
	inx
	dey
	bne	?lp2

?dev:	lda	#CMD_DISK_INQUIRY
	jsr	cmdwait
	bcc	?dev1
	bit	usb0st
	bvc	?off		; disconnected
	bra	?nod
?dev1:	jsr	rddata
	phb
	lda	#^USBBUF
	pha
	plb
	ldx	#$FF
?dev2:	inx	
	lda	!.LOW16.USBBUF+8,x
	cmp	#' '		; skip beginning blanks
	beq	?dev2
	ldy	#0
?dev3:	lda	!.LOW16.USBBUF+8,x
	sta	USB0STR,y
	beq	?dev4
	inx
	iny
	bra	?dev3
?dev4:	plb
	lda	#$E0
	sta	usbdev
	
	jsr	getmbr	

?end:	lda	#CB2IFRB
	sta	!VIA3+VIAIFR
	lda	#CB2IFRB+$80
	sta	!VIA3+VIAIER	; re-enable ch37x interrupt
	rtl

getmbr:
	.EXTERN chkumbr
	
	lda	#1
	sta	seccnt
	lda	#<MBR0USB
	sta	bufp
	lda	#>MBR0USB
	sta	bufp+1
	lda	#^MBR0USB
	sta	bufp+2
	stz	lba
	stz	lba+1
	stz	lba+2
	stz	lba+3
	jsr	readsec
	bcs	?end		; error
	ldx	#2		; drive #2
	jsr	chkumbr		; check mbr
	bcs	?end		; error
	lda	usbdev
	cmp	#$FD
	sec
	bne	?end
	lda	#1
	sta	seccnt
	lda	#<PBR0USB
	sta	bufp
	lda	#>PBR0USB
	sta	bufp+1
	lda	#^PBR0USB
	sta	bufp+2
	lda	usbmbr
	sta	lba
	lda	usbmbr+1
	sta	lba+1
	lda	usbmbr+2
	sta	lba+2
	stz	lba+3		; FAT16 only!!
	jsr	readsec
	bcs	?end
	lda	#$02
	tsb	usbdev		; pbr ok
	
?end:	php
	lda	BiosEnt
	lsr	a
	bcs	?done		; boot phase
	TXT_CR
	jsr	showusb0
	jsr	shusb0fat
?done:	plp
	rts	
	
; read block data
rddata:
	lda	#CMD_RD_USB_DATA
	sta	!usb0cmd
	nop
	nop
	nop
	nop
	lda	!usb0dat
	beq	?end
	tay
	ldx	#0
	sty	usbtmp
?lp:	lda	!usb0dat
	sta	>USBBUF,x
	inx	
	dey
	bne	?lp
	tya
	sta	>USBBUF,x
	lda	usbtmp
?end:	rts

; send command and wait interrupt
cmdwait:	
	sta	!usb0cmd
	lda	#$01
	trb	usb0st		; clear retry flag: bit <0>
?wi:	lda	#CB2IFRB
	bit	!VIA3+VIAIFR
	beq	?wi		; wait interrupt
	sta	!VIA3+VIAIFR	; clear flag
	lda	#CMD_GET_STATUS
	sta	!usb0cmd
	nop			; 2uS
	nop
	nop
	nop
	lda	!usb0dat	; read interrupt code
	cmp	#USB_INT_SUCCESS
	beq	?ok
	cmp	#USB_INT_DISCONNECT
	beq	?off		; disconnected
	bit	usb0ch
	bvc	?chk		; ch375: skip next test
	cmp	#ERR_DISK_DISCON
	beq	?off		; disconnected (ch376 only)
?chk:	cmp	#USB_INT_DISK_ERR
	bne	?nod		; no flash disk
	bit	usb0ch
	bvc	?ch5		; ch375 handle in different way
	lda	#VAR_DISK_STATUS
	jsr	readvar8	; read internal status ch376
	beq	?nod		; unknow device
	cmp	#DEF_DISK_MOUNTED
	bcc	?nod		; unknow device
	bra	?ret		; set retry flag
?ch5:	lda	#CMD_DISK_R_SENSE
	sta	!usb0cmd
?wi2:	lda	#CB2IFRB
	bit	!VIA3+VIAIFR
	beq	?wi2		; wait interrupt
	sta	!VIA3+VIAIFR	; clear flag
	
	lda	#CMD_GET_STATUS
	sta	!usb0cmd
	nop			; 2uS
	nop
	nop
	nop
	lda	!usb0dat	; read interrupt code
	sta	$FD

	cmp	#USB_INT_SUCCESS
	bne	?nod		; unknow device
?ret:	lda	#$01
	tsb	usb0st		; set retry flag
	sec
	rts
?ok:	clc
	rts
?off:	lda	#$40
	trb	usb0st		; clear bit <6>
?nod:	sec
	rts
	
; ch376 specific
; A = var 8
; return A = var. value
readvar8:
	xba
	lda	#CMD_READ_VAR8
	sta	!usb0cmd
	nop
	nop
	nop
	xba
	sta	!usb0dat
	nop
	nop
	nop
	nop
	lda	!usb0dat
	rts

; scan fat table of usb #0 device
; first 64K of dma buffer are reserved to cluster read/write
; scan fat table reading 64 sectors at time
scanufat:
	stz	tlp		; init dma buffer pointer
	stz	tlp+1
	lda	#DMABNK
	sta	tlp+2
	lda	!P0LDT+ldt4+ldt_csiz
	sta	clssiz
	ACC16
	lda	!P0LDT+ldt4+ldt_fat1
	sta	lba		; start sector of fat 1 table
	stz	lba+2
	stz	freecnt		; count of free clusters
	stz	nxtfree		; free next cluster
	stz	cluster		; cluster sequence
	lda	!P0LDT+ldt4+ldt_max
	sta	maxcls		; max. cluster number + 1
	ACC08
	ldx	#0
	lda	!P0LDT+ldt4+ldt_fsiz
	sta	fatsize		; store fat table size
	bne	?st		; less than 256 sectors
	inx			; fat size = 256 sectors
?st:	stx	fatsize+1
	stz	wseccnt+1
	
	ACC16
?lp:	lda	tlp
	sta	bufp
	ldx	tlp+2
	stx	bufp+2
	lda	fatsize
	cmp	#64
	bcc	?less
	lda	#64
?less:	ACC08	
	sta	seccnt		; sectors count #
	sta	wseccnt
	jsr	readsec		; read fat
	bcs	?err		; some errors
	ldy	#0
	CPU16
	lda	wseccnt
	xba
	asl	a		; bytes count #
	sta	bufndx
	ldx	cluster
?lpf:	lda	[tlp],y		; scan fat table
	bne	?nxt		; not free
	inc	freecnt		; update free cluster's count
	lda	nxtfree		; already set?
	bne	?nxt		; yes
	stx	nxtfree		; set first free cluster
?nxt:	inx			; update cluster number
	iny
	iny
	cpx	maxcls		; end of table?
	bcs	?done		; yes
	cpy	bufndx		; end of partial table?
	bcc	?lpf		; no
	stx	cluster		; save current cluster number
	INDEX08
	lda	fatsize
	sec
	sbc	wseccnt
	beq	?done		; end
	sta	fatsize
	clc
	lda	lba
	adc	wseccnt
	bcc	?lp
	inc	lba+2
	bra	?lp
?done:	CPU08
	clc
?err:	ACC16
	lda	freecnt
	sta	!P0LDT+ldt4+ldt_free
	lda	nxtfree
	sta	!P0LDT+ldt4+ldt_nxt
	ACC08
	rts
	
; read sector(s)
readsec:
	lda	#CB2IFRB
	sta	!VIA3+VIAIER	; disable ch37x interrupt
	lda	#CB2IFRB
	sta	!VIA3+VIAIFR	; clear flag
	lda	#CMD_DISK_READ	; start to read sector(s)
	sta	!usb0cmd
	nop
	nop
	stz	sec256
	lda	lba		; send starting lba
	sta	!usb0dat
	nop
	lda	lba+1
	sta	!usb0dat
	nop
	lda	lba+2
	sta	!usb0dat
	nop
	lda	lba+3
	sta	!usb0dat
	lda	seccnt		; sector(s) count #
	bne	?go
	dec	a
	sta	sec256
	sta	seccnt
?go:	sta	!usb0dat
	
	stz	bufndx
	stz	bufndx+1	
	lda	#$08		; 8 packets per sector
	sta	pktcnt
	bra	?wi
	
?sct:	lda	#$08		; 8 packets per sector
	sta	pktcnt	
?pkt:	lda	#CMD_DISK_RD_GO	; read next packet
	sta	!usb0cmd
	nop
	nop
?wi:	jsr	waitint		; wait ch interrupt
	cmp	#USB_INT_DISK_READ
	bne	?done		; finish or error
	lda	#CMD_RD_USB_DATA
	sta	!usb0cmd	; read a packet (64 bytes)
	nop
	nop
	nop
	nop
	ldx	!usb0dat
	cpx	#$40
	bne	?err
	
	INDEX16
	ldy	bufndx		; current buffer index
?rdl:	lda	!usb0dat	; read & store loop
	sta	[bufp],y
	iny
	dex
	bne	?rdl
	sty	bufndx
	INDEX08
	dec	pktcnt		; more packets to read?
	bne	?pkt		; yes
	ACC16CLC
	lda	bufp+1
	adc	#$0002		; update: add 512
	sta	bufp+1
	stz	bufndx
	ACC08
	dec	seccnt
	bne	?sct		; next sector if any
	bra	?pkt		; get last interrupt
	
?done:	cmp	#USB_INT_SUCCESS
	bne	?tst		; test error condition
	lda	pktcnt		; pktcnt & seccnt must be both zero
	ora	seccnt
	bne	?sec
	bit	sec256
	bpl	?ok		; finish
	; read one more sector
	ACC16CLC
	lda	lba
	adc	#255
	sta	lba
	lda	lba+2
	adc	#0
	sta	lba+2
	ACC08
	inc	seccnt
	jmp	readsec
?ok:	clc
	bra	?end
?tst:	cmp	#USB_INT_DISCONNECT

	sta	$ff
	
	beq	?off		; device unplugged
	cmp	#USB_INT_BUF_OVER
	beq	?err		; sense disk error
	cmp	#USB_INT_DISK_ERR
	beq	?err
	jsr	dskrdy
	bcs	?off		; unplugged?
	bra	?sec
?err:	jsr	dskerr
	bra	?sec
?off:	lda	#$7F
	trb	usb0st
?sec:	sec			; error flag
?end:	lda	#CB2IFRB	; clear CB2 flag
	sta	!VIA3+VIAIFR
	lda	#CB2IFRB+$80
	sta	!VIA3+VIAIER	; re-enable ch37x interrupt
	rts

; test disk ready
dskrdy:
	lda	#CMD_DISK_READY
	sta	!usb0cmd
	nop
	jsr	waitint
	cmp	#USB_INT_SUCCESS
	clc
	beq	?end
	sec
?end:	rts

; sensing disk error
dskerr:
	lda	#CMD_DISK_R_SENSE
	sta	!usb0cmd
	nop
	jsr	waitint
	cmp	#USB_INT_SUCCESS
	beq	?get
	sec			; error
	rts
?get:	jsr	delay5ms	
	jsr	rddata		; get error string
	clc
	rts

waitint:
	lda	#CB2IFRB
	bit	!VIA3+VIAIFR
	beq	waitint		; wait interrupt
	sta	!VIA3+VIAIFR	; clear flag
	lda	#CMD_GET_STATUS
	sta	!usb0cmd
	nop			; 2uS
	nop
	nop
	nop
	lda	!usb0dat	; read interrupt code
	rts

showusb0:
	.PUBLIC showusb0

	bit	usb0st
	bvc	?end		; no device plugged
	bit	usbdev
	bpl	?unkn		; unknow device
	ACC16CLC
	lda	usbsec
	sta	lba
	lda	usbsec+2
	ldx	#11		; divide by 2048 (11 shift)...
?shr:	lsr	a		; ... and get rounded size in Mb
	ror	lba
	dex
	bne	?shr
	sta	lba+2
	pha			; 2
	lda	lba
	pha			; 2
	ACC08
	lda	#^USB0STR	; bank that hold device string
	pha
	pea	#USB0STR
	phk			; format string
	pea	#?fstr
	lda	#11
	pha
	BPRINTF
	rts
	
?unkn:	SCNPRINT
	.DB	'usb   #0:  unknow device (not flash disk).', $0D, $00
?end:	rts

?fstr:	
	;.DB	'usb   #0:  flash disk:   %-42.41s %,7u Mb', 13, 0
	.DB	'usb   #0:  usb drive E:  %-42.41s %,7u Mb', 13, 0

shusb0fat:
	.PUBLIC shusb0fat
	.EXTERN lusbldt

	bit	usbdev
	bpl	?end		; no disk device plugged
	jsl	lusbldt
	bcs	?end
	jsr	scanufat	
	ACC16			; print summary	
	lda	maxcls
	dec	a
	dec	a
	sta	maxcls
	ACC08
	lda	clssiz
	pha
	pei	(freecnt)
	pei	(maxcls)
	phk
	pea	#!?fstr
	lda	#9
	pha
	BPRINTF
	clc
?end:	rts

?fstr:	.DB	'%,hu cluster(s) (free: %,hu, 1 cluster=%bu sector(s)).', 13, 0


T10MS	.EQU	(10 * 1000 * PHI2)
delay10ms:
	lda	#$20		; T2 count PHI2 pulses
	trb	VIA0+VIAACR
	lda	#<T10MS
	sta	!VIA0+VIAT2CL
	lda	#>T10MS
	sta	!VIA0+VIAT2CH
?wl:	lda	!VIA0+VIAIFR
	bit	#T2IFRB
	beq	?wl
	rts

T01MS	.EQU	(1000 * PHI2)
delay1ms:
	lda	#$20		; T2 count PHI2 pulses
	trb	VIA0+VIAACR
	lda	#<T01MS
	sta	!VIA0+VIAT2CL
	lda	#>T01MS
	sta	!VIA0+VIAT2CH
?wl:	lda	!VIA0+VIAIFR
	bit	#T2IFRB
	beq	?wl
	rts

T05MS	.EQU	(5000 * PHI2)
delay5ms:
	lda	#$20		; T2 count PHI2 pulses
	trb	VIA0+VIAACR
	lda	#<T05MS
	sta	!VIA0+VIAT2CL
	lda	#>T05MS
	sta	!VIA0+VIAT2CH
?wl:	lda	!VIA0+VIAIFR
	bit	#T2IFRB
	beq	?wl
	rts
	
T32US		.EQU	(32 * PHI2)

delay32us:
	lda	#$20		; T2 count PHI2 pulses
	trb	VIA0+VIAACR
	lda	#T32US
	sta	!VIA0+VIAT2CL
	stz	!VIA0+VIAT2CH
?55:	lda	!VIA0+VIAIFR
	bit	#T2IFRB
	beq	?55
	rts
	